<!DOCTYPE html>
<html>
  <head>
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <title>Stock App</title>
    <style>
      .container {
        padding: 16px;
      }
      body {
        font-family: Arial, Helvetica, sans-serif;
      }
      form {
        border: 3px solid #f1f1f1;
      }

      input[type='text'],
      input[type='password'] {
        width: 100%;
        padding: 12px 20px;
        margin: 8px 0;
        display: inline-block;
        border: 1px solid #ccc;
        box-sizing: border-box;
      }

      button {
        background-color: #04aa6d;
        color: white;
        padding: 14px 20px;
        margin: 8px 0;
        border: none;
        cursor: pointer;
        width: 100%;
      }

      button:hover {
        opacity: 0.8;
      }
      #chart {
        height: 400px;
        margin: 1em auto;
        position: relative;
        animation-duration: 0.3s;
        padding: 2em;
      }
      /* Define the tooltip */
      .linechart-tooltip {
        background: black;
        color: white;
        padding: 0.25em 0.5em;
        margin-top: -1em;
        transition: left 0.1s linear, top 0.1s linear;
        border-radius: 4px;
        white-space: nowrap;
      }
      .linechart-tooltip::after {
        content: '';
        position: absolute;
        bottom: auto;
        width: 0;
        height: 0;
        border: 0.5em solid transparent;
        left: 50%;
        top: 100%;
        transform: translate3d(-50%, 0, 0);
        border-color: transparent;
        border-top-color: black;
      }
    </style>
    <script src="/lib/odi.linechart.min.js"></script>
    <script src="https://cdn.socket.io/3.1.3/socket.io.min.js"></script>
  </head>
  <body>
    <center><h2>Stock App</h2></center>
    <center>
      <button style="width: 100px" type="button" onclick="logout()">
        Logout
      </button>
    </center>
    <br />
    <br />
    <form method="post" style="width: 50%; margin: auto" autocomplete="off">
      <div class="container">
        <label for="sym"><b>Enter Company Symbol</b></label>
        <input type="text" placeholder="Enter Company Symbol" name="sym" />

        <button type="button" onclick="scan()">Scan</button>
      </div>
    </form>
    <center class="loader" style="margin-top: 40px; display: none">
      <img src="/lib/Settings.gif" />
    </center>

    <div id="chart"></div>
  </body>
  <script>
    var socket = io();
    socket.connect();
    socket.emit('join', { email: '<%= email %>' });
    socket.on('scan_error', function (response) {
      alert(response);
      document.querySelector('.loader').style.display = 'none';
      document.getElementById('chart').innerHTML = '';
    });
    socket.on('stock', function (response) {
      document.querySelector('.loader').style.display = 'none';

      // Line Values
      let prices = [];
      let dates = [];
      let lineValues = [];
      for (let i in response.data) {
        lineValues.push({
          x: new Date(response.data[i].timestamp).getTime(),
          y: parseFloat(response.data[i].closing_price),
        });
        prices.push(parseFloat(response.data[i].closing_price));
        dates.push(new Date(response.data[i].timestamp).getTime());
      }

      let minPrice = Math.min.apply(null, prices),
        maxPrice = Math.max.apply(null, prices),
        minTime = Math.min.apply(null, dates),
        maxTime = Math.max.apply(null, dates);
      let priceStep = (maxPrice - minPrice) / 10;
      let timeStep = parseInt((minTime - maxTime) / 10);
      let xAxis = {};
      let yAxis = {};

      for (let i = 1; i <= 10; i++) {
        xAxis[minTime + timeStep * i] = {
          label: new Date(minTime + timeStep * i)
            .toISOString()
            .slice(0, 19)
            .replace('T', ' '),
        };
        yAxis[minPrice + priceStep * i] = {
          label: parseFloat(minPrice + priceStep * i).toFixed(2),
        };
      }
      ODI.ready(() => {
        document.getElementById('chart').innerHTML = '';
        chart = ODI.linechart(document.getElementById('chart'), {
          left: 50,
          right: 10,
          top: 10,
          bottom: 24,
          key: { show: true },
          axis: {
            x: {
              line: { show: true },
              grid: { show: true },

              labels: xAxis,
              title: { label: 'Time' },
            },
            y: {
              line: { show: false, 'stroke-width': 2 },
              grid: { show: true },
              labels: yAxis,
            },
          },
        });
        // Add the data to the chart
        chart.addSeries(lineValues, {
          title: 'Closing Price',
          points: { size: 4, color: '#FF6700' },
          line: { color: '#FF6700' },
          tooltip: {
            label: (d) => {
              return new Date(d.data.x)
                .toISOString()
                .slice(0, 19)
                .replace('T', ' ');
            },
          },
        });
        chart.draw();
        document.querySelector('.loader').style.display = 'none';
        document.querySelector('#chart').style.display = 'block';
      });
    });
  </script>
  <script>
    function scan() {
      document.querySelector('.loader').style.display = 'block';
      document.getElementById('chart').innerHTML = '';
      socket.emit('scan', { id: '<%= id %>',email: '<%= email %>', sym: document.querySelector('[name=sym]').value });
    }
  </script>
  <script>
    function logout() {
      let xhttp;
      xhttp = new XMLHttpRequest();
      xhttp.responseType = 'json';

      xhttp.onreadystatechange = function () {
        if (this.readyState == 4) {
          window.location.href = '/';
        }
      };
      xhttp.open('POST', '/api/auth/logout', true);
      xhttp.setRequestHeader('Content-Type', 'application/json;charset=UTF-8');
      xhttp.send();
    }
  </script>
</html>
